Function autowall_Initialize(msgPort As Object, userVariables As Object, bsp as Object)

    print "=== autowall_Initialize - entry"

    autowall = newAutowall(msgPort, userVariables, bsp)

    return autowall

End Function


Function newAutowall(msgPort As Object, userVariables As Object, bsp as Object)

    print "=== newAutowall"

    'Defaults to 37
    ptpDomain = "37"
    if userVariables.doesExist("ptp_domain")
        'The user has updated the user variable
        ptpDomain = userVariables.ptp_domain.currentValue$
    endif
    if ptpDomain <> bsp.registrySection.read("ptp_domain")
        bsp.registrySection.write("ptp_domain", ptpDomain)
        bsp.registrySection.flush()
        RebootSystem()
    endif


    ' Create the object to return and set it up
    s = {}
    s.scriptVersion = "1.8"
    s.msgPort = msgPort
    s.userVariables = userVariables
    s.bsp = bsp
    s.ProcessEvent = autowall_ProcessEvent
    s.CheckMrssContentUpdate = CheckMrssContentUpdate
    s.MrssToHtmlFile = MrssToHtmlFile
    s.sendTextToHtmlTicker = sendTextToHtmlTicker
    s.objectName = "autowall"
    s.feedIsInQueue = false
    s.tickerFeedIsInQueue = false
    s.rotateLSLandscape = rotateLSLandscape
    s.rotateAutoWallLandscape = rotateAutoWallLandscape
    s.monitorOrientation =  bsp.sign.monitorOrientation
    s.vm = createObject("roVideoMode")
    s.model = createObject("roDeviceInfo").getmodel()
    s.ptpDomain = ptpDomain


    it = 0
    s.urls = []
    for each item in bsp.htmlsites
        s.urls[it] = bsp.htmlsites[item]
        it = it + 1
    end for
    if s.monitorOrientation <> "landscape"
     'Rotate the widget if it's not landscape, and if it's LS, limit the framerate'
      if createObject("roDeviceInfo").getmodel() = "LS423"
         s.rotateLSLandscape()
      else
         s.rotateAutoWallLandscape()
      end if
    end if

    s.deviceName = 	lcase(bsp.registrysection.read("un"))

    s.isMaster = false
    if s.deviceName = "a-1"
        s.isMaster = true
    end if
    s.ipAddress = bsp.sysinfo.ipaddresswired$
    s.htmlWidget = invalid
    s.htmlWidgetReady = false
    s.bezelsNotSet = true
    s.htmlWidgetReload = false

    return s

End Function

Function autowall_ProcessEvent(event As Object) as boolean
    print "=== autowall_ProcessEvent - type of event is ";type(event)
    'print event
    if type(event) = "roHtmlWidgetEvent"
        eventData = event.getData()
         if type(eventData) = "roAssociativeArray" and type(eventData.reason) = "roString" then
             if eventData.reason = "message" then
                if eventData.message.htmlready = "true"
                  if m.monitorOrientation <> "landscape" AND m.htmlWidgetReady <> true
                    'Rotate the widget if it's not landscape, and if it's LS, limit the framerate'
                    if createObject("roDeviceInfo").getmodel() = "LS423"
                       m.rotateLSLandscape()
                    else
                       m.rotateAutoWallLandscape()
                    end if
                    m.htmlWidgetReload = true
                  end if
                  m.htmlWidgetReady = true
                endif
             end if
         end if
    end if
    'sleep(2000)

    if m.htmlWidgetReady AND m.bsp.sysinfo.ipaddresswired$ <> "Invalid" AND m.bezelsNotSet
        m.ipAddress = m.bsp.sysinfo.ipaddresswired$
        if m.htmlWidget = invalid OR m.htmlWidgetReload then
            m.htmlWidget = FindHtmlWidget(m.bsp)
            'TODO this is here because the postJSMessage is returning false on subsequent publishes
            'TODO remove this sleep and find root cause, maybe need to call this plugin from JS first
            sleep(1000)

            bezelWidth = 0
            if type(m.uservariables.bezelWidth) = "roAssociativeArray"
                if m.uservariables.bezelWidth.currentValue$ <> invalid
                    bezelWidth = m.uservariables.bezelWidth.currentValue$
                end if
            end if
            bezelHeight = 0
            if type(m.uservariables.bezelHeight) = "roAssociativeArray"
                if m.uservariables.bezelHeight.currentValue$ <> invalid
                    bezelHeight = m.uservariables.bezelHeight.currentValue$
                end if
            end if
            screenWidth = 0
            if type(m.uservariables.screenWidth) = "roAssociativeArray"
                if m.uservariables.screenWidth.currentValue$ <> invalid
                    screenWidth = m.uservariables.screenWidth.currentValue$
                end if
            end if
            screenHeight = 0
            if type(m.uservariables.screenHeight) = "roAssociativeArray"
                if m.uservariables.screenHeight.currentValue$ <> invalid
                    screenHeight = m.uservariables.screenHeight.currentValue$
                end if
            end if

            jsMessageArr = {
                isMaster          :  m.isMaster,
                deviceName        :  m.deviceName,
                ipAddress         :  m.ipAddress,
                bezelWidth        :  bezelWidth,
                bezelHeight       :  bezelHeight,
                screenWidth       :  screenWidth,
                screenHeight      :  screenHeight,
                monitorOrientation:  m.bsp.sign.monitorOrientation,
                model             :  m.model,
                ptpDomain         :  m.ptpDomain
            }
            ?jsMessageArr
            ?m.htmlWidget.PostJSMessage(jsMessageArr)
            if m.feedIsInQueue
                m.MrssToHtmlFile()
            endif
            if m.tickerFeedIsInQueue
                m.sendTextToHtmlTicker()
            end if
            m.bezelsNotSet = false
        end if
    end if

    if type(event) = "roAssociativeArray" then
        if type(event["EventType"]) = "roString"
            if (event["EventType"] = "MRSS_DATA_FEED_LOADED") then
                print "$_$_$_$_$_$_$_$_$_$"
                feedName$ = event["Name"]
                retval = m.CheckMrssContentUpdate(feedName$)
                if m.htmlWidgetReady
                    if retval then
                        m.MrssToHtmlFile()
                    endif
                else
                    m.feedIsInQueue = true
                endif
            else if (event["EventType"] = "LIVE_DATA_FEED_UPDATE") then
                print "@_@_@_@_@_@_@_@_@"
                'print event
                'print event.EventData
                'print "articles:"
                'print event.EventData.articles
                if event.EventData.usage$ = "text" then
                    m.tickerFeed = {}
                    m.tickerFeed.feedName = "ticker"
                    m.tickerFeed.articles = event.EventData.articles
                    if m.htmlWidgetReady
                        m.sendTextToHtmlTicker()
                    else
                        m.tickerFeedIsInQueue = true
                    end if
                end if
            end if
        end if
    end if

    if type(event) = "roNetworkAttached" or type(event) = "roNetworkDetached" then
        if m.htmlwidget <> invalid
            networkInterface% = event.GetInt()

            if type(event) = "roNetworkAttached" then
                nc = CreateObject("roNetworkConfiguration", networkInterface%)
                if type(nc) = "roNetworkConfiguration" then
                    currentConfig = nc.GetCurrentConfig()
                    if type(currentConfig) = "roAssociativeArray" then
                        if currentConfig.ip4_address <> "" then
                            if networkInterface% = 0 then
                                jsMessageArr = {
                                    networkAttached :  m.isMaster,
                                    ipAddress       :  currentConfig.ip4_address,
                                }
                                ?jsMessageArr
                                ?m.htmlWidget.PostJSMessage(jsMessageArr)
                            endif
                        endif
                    endif
                endif
                nc = invalid
            else
                if networkInterface% = 0 then
                    jsMessageArr = {
                        networkDetached :  "true"
                    }
                    ?jsMessageArr
                    ?m.htmlWidget.PostJSMessage(jsMessageArr)
                endif
            endif
        endif
    end if

    return false

End Function

Function CheckMrssContentUpdate(feedName$ As String) As Boolean

    print ">>>> MRSS content update finished"
    dataFeed = m.bsp.liveDataFeeds.Lookup(feedName$)
    ' Create mapping from file name to pool file paths
    m.feedResult = {}
    m.feedResult.feedName = feedName$
    print "feedName$: ";feedName$
    m.feedResult.articles = CreateObject("roArray", 1, true)
    for each item in dataFeed.feed.items
        if Len(item.title) > 0 then
            poolPath$ = GetPoolFilePath(dataFeed.assetPoolFiles, item.url)
            if Len(poolPath$) > 0 then
                feedItem = {}
                feedItem.url = "file:///" + poolPath$
                feedItem.title = item.title
                feedItem.description = item.description
                feedItem.type = item.type
                m.feedResult.articles.push(feedItem)
            end if
        end if
    next
    return true
End Function

Sub MrssToHtmlFile()

    ' find the baZone in the list of zones
    for each baZone in m.bsp.sign.zonesHSM

        if baZone.loadingHtmlWidget <> invalid then

            print "=== Found HTML Zone, setting message port"
            baZone.loadingHtmlWidget.SetPort(m.msgPort)
            print "=== Found HTML Zone, posting messsage"

            binaryData = CreateObject("roByteArray")
            feedJsonStr = FormatJson(m.feedResult.articles)
            binaryData.FromAsciiString(feedJsonStr)
            base64 = binaryData.ToBase64String()
            sendAA = {}
            'sendAA.feedName = m.feedResult.feedName + "~~~~" +  base64
            sendAA.feedName = m.feedResult.feedName
            sendAA.base64 = base64
            print "=== SendAA=";sendAA

            postSuccessful = baZone.loadingHtmlWidget.PostJSMessage(sendAA )
            print "PostJSSuccessful: "; postSuccessful

        end if
    end for
End Sub

Sub rotateLSLandscape()
    for each baZone in m.bsp.sign.zonesHSM
            ? baZone; "rotateLandscape"
            if baZone.loadingHtmlWidget <> invalid then
                print "=== Found HTML Zone, setting message port"
                baZone.loadingHtmlWidget.SetPort(m.msgPort)
                m.htmlwidget = baZone.loadingHtmlWidget
                print "=== Found HTML Zone, posting messsage"
                   'postSuccessful = baZone.loadingHtmlWidget.setTransform("rot90.50")
                m.htmlwidget.hide()
                m.htmlwidget.setTransform("rot90.50")
                m.htmlwidget.setUrl("file:///"+m.urls[0].prefix$+"/"+m.urls[0].filepath$)
                m.htmlwidget.show()
                'print "Rotate90.50: "; postSuccessful

            end if
       end for
End Sub

Sub rotateAutoWallLandscape()
    for each baZone in m.bsp.sign.zonesHSM

            if baZone.loadingHtmlWidget <> invalid then

                print "=== Found HTML Zone, setting message port"
                baZone.loadingHtmlWidget.SetPort(m.msgPort)
                print "=== Found HTML Zone, posting messsage"
                postSuccessful = baZone.loadingHtmlWidget.setTransform("rot90")
                print "Rotate90: "; postSuccessful

            end if
       end for
End Sub

Sub sendTextToHtmlTicker()
    print "tickerFeed: "
    print m.tickerFeed
    for each baZone in m.bsp.sign.zonesHSM

            if baZone.loadingHtmlWidget <> invalid then

                print "=== Found HTML Zone, setting message port"
                baZone.loadingHtmlWidget.SetPort(m.msgPort)
                print "=== Found HTML Zone, posting messsage"

                binaryData = CreateObject("roByteArray")
                feedJsonStr = FormatJson(m.tickerFeed.articles)
                binaryData.FromAsciiString(feedJsonStr)
                base64 = binaryData.ToBase64String()
                sendAA = {}
                sendAA.feedName = m.tickerFeed.feedName
                sendAA.base64 = base64
                print "=== SendAA=";sendAA

                postSuccessful = baZone.loadingHtmlWidget.PostJSMessage(sendAA )
                print "PostJSSuccessful: "; postSuccessful

            end if
        end for
End Sub

Function FindHTMLWidget(bsp)
    for each baZone in bsp.sign.zonesHSM
        if baZone.loadingHtmlWidget <> invalid then
            return baZone.loadingHtmlWidget
        end if
    end for
    print "Couldn't find htmlwidget"
    return false
End Function